#ifndef __FFNNs_H__INCLUDED
#define __FFNNs_H__INCLUDED
#include <iostream>
#include <fstream>
#include <sstream>
#include "Matrix.h"
#include "FFNN.h"

/////////////////////////////////////////////////////////////
// FFNNsNXij[lbg[NWjŎgpϐ
/////////////////////////////////////////////////////////////
class FFNNs {
private:
public:
	//lbg[N̑
	int NNs;
	//w
	int layerN;
	//lbg[N̍\
	int* structure;
	//wK
	int iterations = 1000;
	//~job`̃TCY
	int batch_size = 1;
	//wK
	double eta = 0.1;
	//wK@̎
	int typeOfLearning = 0;
	//wKp[^
	double mu = 0;
	double rho = 0;
	//LASSOAq
	double lambda = 0;

	//dݏq
	double weightFactor = 1.0;
	//oCAXq
	double biasFactor = 1.0;

	//elbg[N̑l
	double* lossVales;
	//łwKi񂾃lbg[N̔ԍ
	int* ranking;
	//ł֐
	double bestLossValue = 10000.0;

	//dݍs[wԍ][o͔ԍ][͔ԍ]
	Matrix *W;
	//jbgl
	Matrix *Z;
	//oCAX
	Matrix *B;

	FFNN* nns;
	FFNNs() {
	
	}
	FFNNs(int _NNs, int _layerN, int* _structure) {
		init( _NNs, _layerN, _structure);
	}

	virtual void initFFNN() {
		nns = new FFNN[NNs];
	}

	void init(int _NNs, int _layerN, int* _structure) {

		NNs = _NNs;
		layerN = _layerN;
		structure = new int[layerN];
		for (int n = 0; n < layerN; n++) {
			structure[n] = _structure[n];
		}
		init();

	}

	void init() {

		lossVales = new double[NNs];
		ranking = new int[NNs];

		initFFNN();

		for (int i = 0; i < NNs; i++) {
			ranking[0] = i;
			nns[i].init(layerN, structure);

		}


		W = new Matrix[layerN - 1];
		Z = new Matrix[layerN];
		B = new Matrix[layerN - 1];
		for (int n = 0; n < layerN; n++) {
			Z[n] = Matrix(structure[n], 1); //icxNgj
		}
		for (int n = 0; n < layerN - 1; n++) {
			W[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			B[n] = Matrix(structure[n + 1], 1); //icxNgj
		}

	}

	virtual ~FFNNs() {
		delete[] structure;
		delete[] lossVales;
		delete[] W;
		delete[] Z;
		delete[] B;
		delete[] nns;
	}

	//lbg[N̊wKs
	void learnNetworks();
	//wKʂɂ郉LO쐬
	void calculateNetworkRanking();
	//wK̏d݂ƃoCAXo
	void dumpNetwork(std::ofstream &ofs_weight);
	//wK̏d݂ƃoCAX̓ǂݍ
	void readDumpNetwork(std::ifstream &if_weight);
	//ׂĂ̏d݂ƃoCAXǂݍ݃f[^ōĐݒ
	void loadNetwork();
	//wKlbg[Npj[lbg[NvZs
	void calculateByBestNeuralNetwork(double* _input, double* _output);
	//wKlbg[Npj[lbg[NvZsiϒlj
	void calculateByMeanOfTopNeuralNetwork(int N, double* _input, double* _output);
	//d݂ƃoCAXqݒ
	void adoptFactor(double _weightFactor, double _biasFactor);
	//ʃlbg[Nʃlbg[N֍XV
	void updateLowerToHigher();
};

#endif //__FFNNs_H__INCLUDED
