//xxNgivg^Cv錾j
Vector3 RK4_A(double t, Vector3 r, Vector3 v);
//xxNg
Vector3 RK4_V(double t, Vector3 r, Vector3 v) {
	return v.clone();
}

//QENb^@ɂ鎞ԔW
void RK4(double dt, double t, Vector3 r, Vector3 v, Vector3 *output_r_ptr, Vector3 *output_v_ptr) {

	Vector3 v1 = RK4_V(t, r, v);
	Vector3 a1 = RK4_A(t, r, v);

	Vector3 _v1 = Vector3(r.x + v1.x*dt / 2.0, r.y + v1.y*dt / 2.0, r.z + v1.z*dt / 2.0);
	Vector3 _a1 = Vector3(v.x + a1.x*dt / 2.0, v.y + a1.y*dt / 2.0, v.z + a1.z*dt / 2.0);
	Vector3 v2 = RK4_V(t + dt / 2.0, _v1, _a1);
	Vector3 a2 = RK4_A(t + dt / 2.0, _v1, _a1);

	Vector3 _v2 = Vector3(r.x + v2.x*dt / 2.0, r.y + v2.y*dt / 2.0, r.z + v2.z*dt / 2.0);
	Vector3 _a2 = Vector3(v.x + a2.x*dt / 2.0, v.y + a2.y*dt / 2.0, v.z + a2.z*dt / 2.0);
	Vector3 v3 = RK4_V(t + dt / 2.0, _v2, _a2);
	Vector3 a3 = RK4_A(t + dt / 2.0, _v2, _a2);

	Vector3 _v3 = Vector3(r.x + v3.x*dt, r.y + v3.y*dt, r.z + v3.z*dt);
	Vector3 _a3 = Vector3(v.x + a3.x*dt, v.y + a3.y*dt, v.z + a3.z*dt);
	Vector3 v4 = RK4_V(t + dt, _v3, _a3);
	Vector3 a4 = RK4_A(t + dt, _v3, _a3);

	output_r_ptr->x = dt / 6.0 * (v1.x + 2.0 * v2.x + 2.0 * v3.x + v4.x);
	output_r_ptr->y = dt / 6.0 * (v1.y + 2.0 * v2.y + 2.0 * v3.y + v4.y);
	output_r_ptr->z = dt / 6.0 * (v1.z + 2.0 * v2.z + 2.0 * v3.z + v4.z);
	output_v_ptr->x = dt / 6.0 * (a1.x + 2.0 * a2.x + 2.0 * a3.x + a4.x);
	output_v_ptr->y = dt / 6.0 * (a1.y + 2.0 * a2.y + 2.0 * a3.y + a4.y);
	output_v_ptr->z = dt / 6.0 * (a1.z + 2.0 * a2.z + 2.0 * a3.z + a4.z);

}