#ifndef __Vector3_H__INCLUDED
#define __Vector3_H__INCLUDED

#include <math.h>

class Vector3 {
private:
public:
	//vpeB
	double x, y, z;
	//RXgN^
	Vector3() {
		x = y = z = 0;
	}
	Vector3(double _x, double _y, double _z) {
		x = _x;
		y = _y;
		z = _z;
	}
	//fBXgN^
	~Vector3() {};

	//I[o[[h
	Vector3& operator = (const Vector3&);
	friend void operator *= (Vector3&, const Vector3&);
	friend void operator += (Vector3&, const Vector3&);
	friend Vector3 operator * (const Vector3&, const Vector3&);
	friend Vector3 operator * (const Vector3&, double);
	friend Vector3 operator * (double, const Vector3);
	friend Vector3 operator + (const Vector3&, const Vector3&);
	friend Vector3 operator + (const Vector3&, double);
	friend Vector3 operator + (double, const Vector3&);
	friend Vector3 operator - (const Vector3&, const Vector3&);
	friend Vector3 operator - (const Vector3&, double);
	friend Vector3 operator - (double, const Vector3&);
	friend Vector3 operator / (const Vector3&, const Vector3&);
	friend Vector3 operator / (const Vector3&, double);
	friend Vector3 operator / (double, const Vector3);

	//ÓIo֐
	static double dot(Vector3&, Vector3&);           //
	static double distanceSq(Vector3&, Vector3&);    //̂Q
	static double distance(Vector3&, Vector3&);      //
	static double lengthSq(Vector3&);                //̂Q
	static double length(Vector3&);                  //
	static Vector3 addVectors(Vector3&, Vector3&);   //a
	static Vector3 subVectors(Vector3&, Vector3&);   //
	static Vector3 crossVectors(Vector3&, Vector3&); //O
	//o֐
	Vector3 clone();                                 //N[
	Vector3& set(double, double, double);            //xNg̐ݒ
	Vector3& copy(const Vector3&);                   //Rs[
	Vector3& add(Vector3&);                          //a
	Vector3& sub(Vector3&);                          //
	Vector3& addScalor(double);                      //XJ[a
	Vector3& subScalor(double);                      //XJ[
	Vector3& multiply(double);                       //XJ[
	Vector3& multiply(Vector3&);                     //Ƃ̐
	Vector3& multiplyScalor(double);                 //XJ[
	Vector3& divide(double);                         //XJ[
	Vector3& divide(Vector3&);                       //Ƃ̏
	Vector3& divideScalor(double);                   //XJ[
	Vector3& normalize();                            //Ki
	Vector3& cross(Vector3&);                        //O
	double dot(Vector3&);                            //
	double length();                                 //
	double lengthSq();                               //̂Q
	double angleTo(Vector3&);                        //Ȃp
	double distanceTo(Vector3&);                     //
	double distanceToSquared(Vector3&);              //̂Q
	bool equals(Vector3&);                           //l
};
#endif // __Vector3_H__INCLUDED